Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 331641 (PR45070) - sys-devel/gcc-4.{4,5}*: Miscompiled c++ class with packed attribute on ARM with -Os optimizations (Qt 4.6.2)
Summary: sys-devel/gcc-4.{4,5}*: Miscompiled c++ class with packed attribute on ARM wi...
Status: RESOLVED FIXED
Alias: PR45070
Product: Gentoo Linux
Classification: Unclassified
Component: [OLD] Core system (show other bugs)
Hardware: ARM Linux
: High normal (vote)
Assignee: Gentoo Toolchain Maintainers
URL: http://gcc.gnu.org/PR45070
Whiteboard:
Keywords: Inclusion
Depends on:
Blocks:
 
Reported: 2010-08-08 11:33 UTC by Raúl Porcel (RETIRED)
Modified: 2010-09-16 04:48 UTC (History)
4 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
70_all_gcc44-pr45070-arm_-Os.patch (70_all_gcc44-pr45070-arm_-Os.patch,7.12 KB, patch)
2010-09-11 04:36 UTC, Ryan Hill (RETIRED)
Details | Diff
70_all_gcc45-pr45070-arm_-Os.patch (70_all_gcc45-pr45070-arm_-Os.patch,7.13 KB, patch)
2010-09-11 04:38 UTC, Ryan Hill (RETIRED)
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Raúl Porcel (RETIRED) gentoo-dev 2010-08-08 11:33:19 UTC
This is just for tracking upstream bug and remind that until qt-4.7 is stable or this is fixed, i'm adding this to the qt4-build.eclass:

--- qt4-build.eclass	11 Jul 2010 10:32:17 -0000	1.78
+++ qt4-build.eclass	8 Aug 2010 11:32:34 -0000
@@ -196,6 +196,12 @@
 		replace-flags -O2 -O3
 	fi
 
+	if [[ ${CHOST} == arm* ]] ; then
+		# Fails on arm with -Os
+		# This can be removed once qt-4.7 is stable or the bug on gcc is fixed
+		replace-flags -Os -O2
+	fi
+
 	# Bug 178652
 	if [[ $(gcc-major-version) == 3 ]] && use amd64; then
 		ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
Comment 1 Siarhei Siamashka 2010-08-08 12:01:36 UTC
I'm afraid that just filtering out -Os when compiling Qt libraries may be not enough to solve the issue. Because any Qt/KDE application trying to return QChar from some function may be miscompiled too.
Comment 2 Ryan Hill (RETIRED) gentoo-dev 2010-09-11 04:36:45 UTC
Created attachment 246793 [details, diff]
70_all_gcc44-pr45070-arm_-Os.patch
Comment 3 Ryan Hill (RETIRED) gentoo-dev 2010-09-11 04:38:10 UTC
Created attachment 246794 [details, diff]
70_all_gcc45-pr45070-arm_-Os.patch
Comment 4 Ryan Hill (RETIRED) gentoo-dev 2010-09-11 04:42:08 UTC
Added to 4.4.4 and 4.5.1 patchsets.
Comment 5 Ryan Hill (RETIRED) gentoo-dev 2010-09-16 04:18:36 UTC
Released in 4.4.4-r2.
Comment 6 Ryan Hill (RETIRED) gentoo-dev 2010-09-16 04:48:57 UTC
and 4.5.1 (p1.1).